# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#


from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import ExternalMethod

def installWorkflows(self, package, out):
    """Install the custom workflows for this product.  Called by Install method"""
    #should import from config
    productname = 'SignupSheet'
    workflowTool = getToolByName(self, 'portal_workflow')

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                         productname+'.'+'signupsheet_workflow',
                         'createSignupsheet_workflow')
    workflow = ourProductWorkflow('signupsheet_workflow')
    workflowTool._setObject('signupsheet_workflow', workflow)
    workflowTool.setChainForPortalTypes(['SignupSheet'], workflow.getId())

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                         productname+'.'+'signupsheet_registrant_workflow',
                         'createSignupsheet_registrant_workflow')
    workflow = ourProductWorkflow('signupsheet_registrant_workflow')
    workflowTool._setObject('signupsheet_registrant_workflow', workflow)
    workflowTool.setChainForPortalTypes(['Registrant'], workflow.getId())

    

    return workflowTool
