# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: signupsheet_registrant_workflow/signupsheet_registrant_workflow
# Date: 2006/06/20 16:23:38.793 GMT-7
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# The following scripts have been detected and should be backed up:
# - sendInitialEmail (External Method)
# - sendResolvedMail (External Method)
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.1.1.1 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.SignupSheet.config import *



def setupSignupsheet_registrant_workflow(wf):
    "..."
    wf.setProperties(title='signupsheet_registrant_workflow')

    for s in ['new', 'confirmed', 'unconfirmed']:
        wf.states.addState(s)
    for t in ['accept-unconfirmed', 'post', 'reject-open']:
        wf.transitions.addTransition(t)
    for v in ['action', 'review_history', 'comments', 'actor', 'time']:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Delete objects', 'Modify portal content', 'SignupSheet: Add Registrant','View'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('new')

    ## States initialization
    sdef = wf.states['new']
    sdef.setProperties(title="""Being created""",
                       transitions=('post',))
    sdef.setPermission('Delete objects', 0, ['Anonymous', 'Manager', 'Owner'])
    sdef.setPermission('Modify portal content', 0, ['Anonymous', 'Manager', 'Owner'])
    sdef.setPermission('SignupSheet: Add Registrant', 0, ['Anonymous', 'Manager', 'Owner'])
    sdef.setPermission('View', 1, [])

    sdef = wf.states['confirmed']
    sdef.setProperties(title="""Confirmed""",
                       transitions=('reject-open',))
    sdef.setPermission('Delete objects', 0, ['Manager'])
    sdef.setPermission('Modify portal content', 0, ['Owner', 'Manager'])
    sdef.setPermission('SignupSheet: Add Registrant', 1, [])
    sdef.setPermission('View', 0, ['Manager'])

    sdef = wf.states['unconfirmed']
    sdef.setProperties(title="""Unconfirmed""",
                       transitions=('accept-unconfirmed',))
    sdef.setPermission('Delete objects', 0, ['Manager'])
    sdef.setPermission('Modify portal content', 0, ['Owner', 'Manager'])
    sdef.setPermission('SignupSheet: Add Registrant', 1, [])
    sdef.setPermission('View', 0, ['Manager'])


    ## Creation of workflow scripts
    for wf_scriptname in ['sendInitialEmail']:
        if not wf_scriptname in wf.scripts.objectIds():
            wf.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                'SignupSheet' + '.signupsheet_registrant_workflow_scripts',
                wf_scriptname))

    ## Transitions initialization
    tdef = wf.transitions['accept-unconfirmed']
    tdef.setProperties(title="""confirm""",
                       new_state_id="""confirmed""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""confirm""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props=None,
                       )

    tdef = wf.transitions['post']
    tdef.setProperties(title="""Post issue on save""",
                       new_state_id="""unconfirmed""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""sendInitialEmail""",
                       actbox_name="""Submit registrant""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props=None,
                       )

    tdef = wf.transitions['reject-open']
    tdef.setProperties(title="""Reject""",
                       new_state_id="""unconfirmed""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Reject""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props=None,
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    ## Worklists Initialization

def createSignupsheet_registrant_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupSignupsheet_registrant_workflow(ob)
    return ob

addWorkflowFactory(createSignupsheet_registrant_workflow,
                   id='signupsheet_registrant_workflow',
                   title='signupsheet_registrant_workflow')

    
