#CMF
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent, ManagePortal
from Products.CMFPlone.interfaces.NonStructuralFolder import INonStructuralFolder

#ArcheTypes
from Products.Archetypes.public import *

from Products.SignupSheet.content.registrant import Registrant

#ATSchemaEditorNG
from Products.ATSchemaEditorNG.interfaces import ISchemaEditor
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor
from Products.ATSchemaEditorNG import util

#ATContentTypes
from Products.ATContentTypes.content.base import ATCTOrderedFolder
from Products.ATContentTypes.content.folder import *

#security
from AccessControl import ClassSecurityInfo


#need this for the export tool
import csv
from cStringIO import StringIO

schema = ATFolder.schema.copy() + ConstrainTypesMixinSchema + Schema(( 


IntegerField('eventsize',
             required=1,
             default=0,
             read_permission="SignupSheet: View Registration Info",
             validators=('isInt',),    
             widget=StringWidget(
             description = "Set to 0 for unlimited registration",
             visible={'edit':'visible', 'view':'invisible'},
             size=6,
             label='Number of registrants',)
),


IntegerField('waitlist_size',
             required=1,
             default=0,
             read_permission="SignupSheet: View Registration Info",
             validators=('isInt',),    
             widget=StringWidget(
             description = "",
             visible={'edit':'visible', 'view':'invisible'},
             size=6,
             label='Size of wait list',)
),


 TextField('text',
              required=True,
              searchable=True,
              primary=True,
              validators = ('isTidyHtmlWithCleanup',),
              #validators = ('isTidyHtml',),
              default_output_type = 'text/x-html-safe',
              allowable_content_types=('text/plain',
                                       'text/html'),
              widget = RichWidget(
                        description = "Text for front page of signup",
                        description_msgid = "help_body_text",
                        label = "Body Text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "plone",
               ),
),



TextField("thank_you_text", 
		schemata="thank_you",
        read_permission="SignupSheet: View Thank You",
		default = """Thank you for registering, we will contact you shortly""",
		required=0,
        default_output_type = 'text/x-html-safe',
        default_content_type = 'text/html',
        allowable_content_types=('text/html',),
		widget=RichWidget(
			label="Thank You",
			label_msgid="label_Thank You",
			visible={'edit':'visible', 'view':'invisible'},
			description="""Thank you page for returned to registrant""",
			i18n_domain="plone",
			size=30,
		), 
	), 
	
	
	TextField("email_response", 
		schemata="thank_you",
        read_permission="SignupSheet: View Thank You",
		default = """Thank you for registering.""",
		required=0,
        default_output_type = 'text/plain',
        allowable_content_types=('text/plain',),
		widget=TextAreaWidget(
			label="Email response message",
			label_msgid="label_Thank You",
			visible={'edit':'visible', 'view':'invisible'},
			description="""Email message text that is returned to registrant""",
			i18n_domain="plone",
			size=30,
		), 
	), 

))

class SignupSheet(SchemaEditor, ATFolder, BaseFolder):
    """Container for Registrants"""
    #setup actions for edit and export tools
    actions = ({
        'id'          : 'editschema',
        'name'        : 'edit registrant form',
        'action'      : 'string:${object_url}/signupsheet_schema_editor',
        'permissions': ('Manage portal',),
        'category'    : 'object',
         },
         {
        'id'          : 'view',
        'name'        : 'View',
        'action'      : 'string:${object_url}/signupsheet_view',
        'permissions' : (View, ),
        'category'    : 'object',
         },
         {
        'id'          : 'exportdata',
        'name'        : 'export data',
        'action'      : 'string:${object_url}/export_registrant_fields',
        'permissions': ('Modify portal content',),
        'category'    : 'object',
         },
    )

    security = ClassSecurityInfo()
    
    schema = schema
    portal_type = meta_type =  "SignupSheet"
    archetype_name = 'Signup Sheet'
    immediate_view = 'signupsheet_view'
    default_view   = 'signupsheet_view'
    content_icon   = 'page_edit.gif'
    # Allow images and files to be uploaded into this containerish object
    allowed_content_types = ['Registrant']

    __implements__ = (ATFolder.__implements__,ISchemaEditor) 

# Set up our views - these are available from the 'display' menu
    default_view = 'signupsheet_view'
    immediate_view = 'signupsheet_view'
 
# Make sure we get title-to-id generation when an object is created
    _at_rename_after_creation = True


    """
    Container to act as host for schema editing.
    """
   
    def manage_afterAdd(self, item, container):
        """ """
        # do not show metadata fieldset
        #self.atse_registerObject(getattr(Products.SignupSheet.content.registrant,'Registrant'), ('metadata', ))
        self.atse_registerObject(Registrant, ('metadata', ))
        BaseFolder.manage_afterAdd(self, item, container)


    def _site_encoding(self):
        "Returns the site encoding"
        portal_properties = self.portal_properties
        site_props = portal_properties.site_properties
        return site_props.default_charset or 'utf-8'
   
   
   #Code from UpFront objs product, should be refactored to remove cruft
    security.declareProtected(ModifyPortalContent,'exportCSV')
    def exportCSV(self, fields=None, coding=None,export_type='Registrant'):
        """
        Exports a list of objs as a CSV file.  Wraps generateCSV.       
        """    
               
        #updates schema if not done before export
        self.atse_updateManagedSchema(portal_type=export_type,schema_template='signupsheet_schema_editor') 
        
        result = self.generateCSV(fields=fields)
        
        # encode the result
        charset = self._site_encoding()
        if coding:
            result = result.decode(charset).encode(coding)
        else:
            coding = charset

        # set headers and return
        setheader = self.REQUEST.RESPONSE.setHeader
        setheader('Content-Length', len(result))
        setheader('Content-Type', 
            'text/x-comma-separated-values; charset=%s' % coding)
        setheader('Content-Disposition', 'filename=%s.csv' % self.getId())
        return result
        
        
          #Code based on UpFront objs product, should be refactored to remove cruft
    security.declareProtected(ModifyPortalContent,'generateCSV')
    def generateCSV(self, objs=None, fields=None, delimiter='comma', 
                  quote_char='double_quote', coding=None,
                  export_type='Registrant'):

        """
        Exports a list of objs as a CSV file.
        objs: if None it exports all registrants in the folder.
        fields: field names to export
        """

        #container = self.unrestrictedTraverse(
        #   self.REQUEST.get('current_path'))
        if objs is None:
            objs = self.listFolderContents(
                contentFilter={'portal_type':export_type}
            )

        delim_map = {
            'tabulator':'\t',
            'semicolon':';',
            'colon':':',
            'comma':',',
            'space':' ',
        }

        delimiter = delim_map[delimiter]
        quote_map = {'double_quote':'"', 'single_quote':"'", }
        quote_char = quote_map[quote_char]

        # generate result
        if fields is None:
            result = ''
        else:
            rows = [fields]
            for obj in objs:
                row = []
                #code to append creationDate since it is not part of the fields list
                row.append(obj.CreationDate())
                for fieldname in fields:
                    if fieldname.find('.') != -1:
                        fieldname, key = fieldname.split('.')
                    field = obj.Schema()[fieldname]
                    value = field.getAccessor(obj)()
                    row.append(value)
                rows.append(row)
            rows[0].insert(0,'date')    
            # convert lists to csv string
            ramdisk = StringIO()
            writer = csv.writer(ramdisk, delimiter=delimiter)
            writer.writerows(rows)
            result = ramdisk.getvalue()
            ramdisk.close()

        return result
 
    
    #used by export_registrant_fields to gather fields for export
    security.declareProtected(ModifyPortalContent,'registrantFieldNames')
    def registrantFieldNames(self, import_type):
        "Returns the field names for contact type"
        
        schema = self.atse_getSchemaById(import_type)
        fields = schema.filterFields(isMetadata=0)
        field_names = []
        for field in fields:
            field_names.append(field.getName()) 
        return field_names


    #method to calculate wether the Signupsheet will accept more registrants
    #I dislike using nexstatus but the display button and the registrant creation have different requirements
    def getSignupStatus(self,nextstatus=0):
       """Returns the status of the SignupSheet container"""
       status=''
       event_size = self.getEventsize()
       waitlist_size = self.getWaitlist_size()
       current_size=len(self.contentIds(filter={'portal_type':'Registrant'}))
       max_size = event_size + waitlist_size
       
       if current_size + nextstatus <= event_size:
           status = 'open'     
       elif max_size - current_size <= waitlist_size:
           status = 'waitlist' 

       if current_size >= max_size:
           status = 'full'
       
       if max_size == 0:
           status = 'open'

       return status




registerType(SignupSheet)
